import messageCenter from '@/uilts/messageCenter/content';
import { getCookie, isMobileTwitter } from '@/uilts/help'
import { TaskType } from '@/types';
import axios from 'axios';

/**
 * 发推
 * @param {*} params
 * @returns
 */
const TwitterApiCreateTweet = (params) => {
  let {txt} = params;
  let data = {
    queryId: "hC1nuE-2d1NX5LYBuuAvtQ",
    features: {
        "dont_mention_me_view_api_enabled": true,
        "interactive_text_enabled": true,
        "responsive_web_uc_gql_enabled": false,
        "vibe_api_enabled": true,
        "responsive_web_edit_tweet_api_enabled": false,
        "standardized_nudges_misinfo": true,
        "responsive_web_enhance_cards_enabled": false,
        "tweet_with_visibility_results_prefer_gql_limited_actions_policy_enabled": false,
        "responsive_web_text_conversations_enabled": false
    },
    variables: {
        "tweet_text": txt,
        "media": {
            "media_entities": [],
            "possibly_sensitive": false
        },
        "withDownvotePerspective": true,
        "withReactionsMetadata": false,
        "withReactionsPerspective": false,
        "withSuperFollowsTweetFields": true,
        "withSuperFollowsUserFields": true,
        "semantic_annotation_ids": [],
        "dark_request": false
    }
  };
  let url = isMobileTwitter() ? "https://mobile.twitter.com/i/api/graphql/K9It0MijE2UOlX-8wLyPYA/CreateTweet" : "https://twitter.com/i/api/graphql/hC1nuE-2d1NX5LYBuuAvtQ/CreateTweet"
  return axios.post(url,
      data, {
      headers: {
          "accept": "*/*",
          "accept-language": "zh-CN,zh;q=0.9,en-US;q=0.8,en;q=0.7",
          "authorization": "Bearer AAAAAAAAAAAAAAAAAAAAANRILgAAAAAAnNwIzUejRCOuH5E6I8xnZz4puTs%3D1Zv7ttfk8LF81IUq16cHjhLTvJu4FA33AGWWjCpTnA",
          "content-type": "application/json",
          "sec-ch-ua": "\" Not A;Brand\";v=\"99\", \"Chromium\";v=\"101\", \"Google Chrome\";v=\"101\"",
          "sec-ch-ua-mobile": "?0",
          "sec-ch-ua-platform": "\"Windows\"",
          "sec-fetch-dest": "empty",
          "sec-fetch-mode": "cors",
          "sec-fetch-site": "same-origin",
          "x-csrf-token": getCookie('ct0'),
          "x-twitter-active-user": "yes",
          "x-twitter-auth-type": "OAuth2Session",
          "x-twitter-client-language": "en"
      },
  })
}

const TwitterCreateTweetAPI = ({ info, data }) => {
    TwitterApiCreateTweet({txt: data.txt}).then(function (response) {
        messageCenter.send({ info, data: response.data })
    }).catch(function (err) {
        messageCenter.send({ info, data: {} })
    });
}

const TwitterApiLike = (params) => {
  let {tweetId} = params;
  let url = isMobileTwitter() ? "https://mobile.twitter.com/i/api/graphql/lI07N6Otwv1PhnEgXILM7A/FavoriteTweet" : "https://twitter.com/i/api/graphql/lI07N6Otwv1PhnEgXILM7A/FavoriteTweet"
  return fetch(url, {
        "headers": {
            "accept": "*/*",
            "accept-language": "zh-CN,zh;q=0.9,en-US;q=0.8,en;q=0.7",
            "authorization": "Bearer AAAAAAAAAAAAAAAAAAAAANRILgAAAAAAnNwIzUejRCOuH5E6I8xnZz4puTs%3D1Zv7ttfk8LF81IUq16cHjhLTvJu4FA33AGWWjCpTnA",
            "content-type": "application/json",
            "sec-ch-ua": "\" Not A;Brand\";v=\"99\", \"Chromium\";v=\"101\", \"Google Chrome\";v=\"101\"",
            "sec-ch-ua-mobile": "?0",
            "sec-ch-ua-platform": "\"Windows\"",
            "sec-fetch-dest": "empty",
            "sec-fetch-mode": "cors",
            "sec-fetch-site": "same-origin",
            "x-csrf-token": getCookie('ct0'),
            "x-twitter-active-user": "yes",
            "x-twitter-auth-type": "OAuth2Session",
            "x-twitter-client-language": "en"
        },
        "referrer": "https://twitter.com/home",
        "referrerPolicy": "strict-origin-when-cross-origin",
        "body": "{\"variables\":{\"tweet_id\":\"" + tweetId + "\"},\"queryId\":\"lI07N6Otwv1PhnEgXILM7A\"}",
        "method": "POST",
        "mode": "cors",
        "credentials": "include"
    })
}

const TwitterLikeAPI = ({ info, data }) => {
    TwitterApiLike({tweetId: data.tweetId}).then(() => {
        // 返回信息
        messageCenter.send({ info, data: { task_done: true } })
    }).catch(() => {
        messageCenter.send({ info, data: { task_done: false } })
    })
}

const TwitterApiFollowUser = (params) => {
  let {twitterUserId} = params;
  let url = isMobileTwitter() ? "https://mobile.twitter.com/i/api/1.1/friendships/create.json" : "https://twitter.com/i/api/1.1/friendships/create.json"
  return  fetch(url, {
        "headers": {
            "authorization": "Bearer AAAAAAAAAAAAAAAAAAAAANRILgAAAAAAnNwIzUejRCOuH5E6I8xnZz4puTs%3D1Zv7ttfk8LF81IUq16cHjhLTvJu4FA33AGWWjCpTnA",
            "content-type": "application/x-www-form-urlencoded",
            "sec-ch-ua": "\" Not A;Brand\";v=\"99\", \"Chromium\";v=\"102\", \"Google Chrome\";v=\"102\"",
            "sec-ch-ua-mobile": "?0",
            "sec-ch-ua-platform": "\"macOS\"",
            "x-csrf-token": getCookie('ct0'),
            "x-twitter-active-user": "yes",
            "x-twitter-auth-type": "OAuth2Session",
            "x-twitter-client-language": "zh-cn"
        },
        "referrer": "https://twitter.com/home",
        "referrerPolicy": "strict-origin-when-cross-origin",
        "body": "include_profile_interstitial_type=1&include_blocking=1&include_blocked_by=1&include_followed_by=1&include_want_retweets=1&include_mute_edge=1&include_can_dm=1&include_can_media_tag=1&include_ext_has_nft_avatar=1&skip_status=1&user_id=" + twitterUserId + "",
        "method": "POST",
        "mode": "cors",
        "credentials": "include"
    })
}

const TwitterFollowAPI = ({ info, data }) => {
    TwitterApiFollowUser({twitterUserId: data.twitterUserId}).then(() => {
        messageCenter.send({ info, data: { task_done: true, follow_name: data.follow_name } })
    }).catch(() => {
        messageCenter.send({ info, data: { task_done: false, follow_name: data.follow_name } })
    })
}

const TwitterApiRetweet = (params) => {
  let {tweetId} = params;
  let url = isMobileTwitter() ? "https://mobile.twitter.com/i/api/graphql/ojPdsZsimiJrUGLR1sjUtA/CreateRetweet" : "https://twitter.com/i/api/graphql/ojPdsZsimiJrUGLR1sjUtA/CreateRetweet"
  return  fetch(url, {
        "headers": {
            "accept": "*/*",
            "accept-language": "zh,en;q=0.9,zh-CN;q=0.8",
            "authorization": "Bearer AAAAAAAAAAAAAAAAAAAAANRILgAAAAAAnNwIzUejRCOuH5E6I8xnZz4puTs%3D1Zv7ttfk8LF81IUq16cHjhLTvJu4FA33AGWWjCpTnA",
            "content-type": "application/json",
            "sec-ch-ua": "\" Not A;Brand\";v=\"99\", \"Chromium\";v=\"102\", \"Google Chrome\";v=\"102\"",
            "sec-ch-ua-mobile": "?0",
            "sec-ch-ua-platform": "\"macOS\"",
            "sec-fetch-dest": "empty",
            "sec-fetch-mode": "cors",
            "sec-fetch-site": "same-origin",
            "x-csrf-token": getCookie('ct0'),
            "x-twitter-active-user": "yes",
            "x-twitter-auth-type": "OAuth2Session",
            "x-twitter-client-language": "zh-cn"
        },
        "referrer": "https://twitter.com/home",
        "referrerPolicy": "strict-origin-when-cross-origin",
        "body": "{\"variables\":{\"tweet_id\":\"" + tweetId + "\",\"dark_request\":false},\"queryId\":\"ojPdsZsimiJrUGLR1sjUtA\"}",
        "method": "POST",
        "mode": "cors",
        "credentials": "include"
    })
}

const TwitterRetweetAPI = ({ info, data }) => {
    TwitterApiRetweet({tweetId: data.tweetId}).then(() => {
        messageCenter.send({ info, data: { task_done: true } })
    }).catch(() => {
        messageCenter.send({ info, data: { task_done: false } })
    })
}

/**
 * 订阅 notifation
 * @param {*} params
 * @returns
 */
const TwitterApiFriendshipsUpdate = (params) => {
  let { id = '', device = true, name = '' } = params;
  if (!id) {
      return;
  }
  let url = isMobileTwitter() ? 'https://mobile.twitter.com/i/api/1.1/friendships/update.json' : "https://twitter.com/i/api/1.1/friendships/update.json";
  return fetch(url, {
      "headers": {
          "authorization": "Bearer AAAAAAAAAAAAAAAAAAAAANRILgAAAAAAnNwIzUejRCOuH5E6I8xnZz4puTs%3D1Zv7ttfk8LF81IUq16cHjhLTvJu4FA33AGWWjCpTnA",
          "content-type": "application/x-www-form-urlencoded",
          "sec-ch-ua": "\" Not A;Brand\";v=\"99\", \"Chromium\";v=\"102\", \"Google Chrome\";v=\"102\"",
          "sec-ch-ua-mobile": "?0",
          "sec-ch-ua-platform": "\"macOS\"",
          "x-csrf-token": getCookie('ct0'),
          "x-twitter-active-user": "yes",
          "x-twitter-auth-type": "OAuth2Session",
          "x-twitter-client-language": "en",
          "referer": `https://twitter.com/${name}`
      },
      "referrer": `https://twitter.com/${name}`,
      "referrerPolicy": "strict-origin-when-cross-origin",
      "body": `include_profile_interstitial_type=1&include_blocking=1&include_blocked_by=1&include_followed_by=1&include_want_retweets=1&include_mute_edge=1&include_can_dm=1&include_can_media_tag=1&include_ext_has_nft_avatar=1&skip_status=1&cursor=-1&id=${id}&device=true`,
      "method": "POST",
      "mode": "cors",
      "credentials": "include"
  })
}

/**
 * 一键三连 夺宝任务
 * @param {*} param0
 */
const doTreasureTasks = ({info, data}) => {
    let {tasks = '[]', tweetId, tweetText} = data;
    tasks = JSON.parse(tasks);
    tasks.forEach((item) => {
      switch (item.type) {
          // 关注指定用户
          case TaskType.twitterFollow:
              item.relatedUsers.forEach((item) => {
                if (item.name && item.twitterUserId) {
                  TwitterApiFollowUser({twitterUserId: item.twitterUserId}).then(res => {
                    TwitterApiFriendshipsUpdate({id: item.twitterUserId});
                  })
                }
              })
              break
          // 点赞
          case TaskType.twitterLikeTweet:
              TwitterApiLike({tweetId})
              break
          // 推文发推
          case TaskType.twitterRePost:
              // 发推
              TwitterApiCreateTweet({txt: tweetText}).then(response => {
                messageCenter.send({ info, data: {data: response.data, task_done: true} })
              }).catch(err => {
                messageCenter.send({ info, data: {data: {}, task_done: false} })
              })
              break
      }
  })
}

export default {
    TwitterCreateTweetAPI,
    TwitterLikeAPI,
    TwitterRetweetAPI,
    TwitterFollowAPI,
    doTreasureTasks
}
